using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net; // socket֘A
using System.Net.Sockets;
using System.Threading; // thread֘A

namespace SocketClient
{
    public partial class FormSocketClient : Form
    {
        private System.Text.Encoding enc = System.Text.Encoding.UTF8; // R[h
        private System.Net.Sockets.TcpClient tcp;
        private System.Net.Sockets.NetworkStream ns; // Mp
        private Thread thread;
        private AutoResetEvent threadResetEvent;
        private Boolean threadStopper; // Xbh~tO

        public FormSocketClient()
        {
            InitializeComponent();
            connectInit();
        }

        #region Thread/Socket
        /// <summary>
        /// tcp, thread̏
        /// </summary>
        private void connectInit()
        {
            tcp = new TcpClient();
            threadResetEvent = new AutoResetEvent(false);
        }

        /// <summary>
        /// tcp, thread̔j
        /// </summary>
        private void connectEnd()
        {
            if (tcp.Connected)
            {
                try
                {
                    tcp.Close();
                }
                catch (Exception ex)
                {
                    trace(ex.Message);
                }
                finally
                {
                    threadStopper = true; // XbhItO
                    threadResetEvent.WaitOne(); // XbhI҂
                    thread = null; // j
                }
            }
        }

        /// <summary>
        /// f[^MXbh
        /// </summary>
        private void recvThreadStart()
        {
            byte[] recvBytes;
            int recvSize = 0;
            threadStopper = false;
            while (!threadStopper)
            {
                if (ns.DataAvailable)
                {
                    recvBytes = new byte[256];
                    try
                    {
                        recvSize = ns.Read(recvBytes, 0, recvBytes.Length);
                    }
                    catch (Exception ex)
                    {
                        trace(ex.Message);
                    }
                    trace("Mf[^: " + recvSize);
                    string recvMsg = enc.GetString(recvBytes);
                    trace("Mf[^: "+recvMsg);
                }
                Thread.Sleep(100);
            }
            threadResetEvent.Set(); // XbhIWaitOne()ɒʒm
        }
        #endregion

        #region UI Event

        private void buttonConnect_Click(object sender, EventArgs e)
        {
            if (!tcp.Connected) // qĂȂ
            {
                try
                {
                    tcp.Connect(textBoxAddress.Text, int.Parse(textBoxPort.Text));
                    thread = new Thread(new ThreadStart(recvThreadStart));
                    ns = tcp.GetStream();
                    thread.Start();
                }
                catch (Exception ex)
                {
                    trace(ex.Message);
                }
                finally
                {
                    if (tcp.Connected)
                    {
                        buttonConnect.Text = "DisConnect?";
                        buttonSendMsg.Enabled = true;
                        textBoxAddress.Enabled = false;
                        textBoxPort.Enabled = false;
                    }
                }
            }
            else // qĂ
            {
                connectEnd();

                if (!tcp.Connected)
                {
                    buttonConnect.Text = "Connect!";
                    buttonSendMsg.Enabled = false;
                    textBoxAddress.Enabled = true;
                    textBoxPort.Enabled = true;
                    connectInit(); // Xbh֘A
                }

            }
        }

        private void buttonSendMsg_Click(object sender, EventArgs e)
        {
            if (!tcp.Connected) return;
            byte[] bytes = enc.GetBytes(textBoxMsg.Text);
            try
            {
                ns.Write(bytes, 0, bytes.Length);
            }
            catch (Exception ex)
            {
                trace(ex.Message);
            }
            finally
            {
                trace("M: " + enc.GetString(bytes));
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            connectEnd();
        }
        #endregion

        #region GUI
        /// <summary>
        /// eLXg{bNXɕ\
        /// </summary>
        /// <param name="message"></param>
        public void trace(String message)
        {
            Console.WriteLine(message);
            try
            {
                this.Invoke((MethodInvoker)delegate()
                {
                    textBoxRecv.Text = textBoxRecv.Text + "\r\n" + message;
                });
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }

        #endregion

    }
}