using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net; // socket֘A
using System.Net.Sockets;
using System.Threading; // thread֘A

namespace SocketServer
{
    public enum SocketState
    {
        /// <summary>
        /// ڑ
        /// </summary>
        DisConnect,
        /// <summary>
        /// ڑ҂
        /// </summary>
        Listening,
        /// <summary>
        /// ڑĂ
        /// </summary>
        Connected,
    }

    public partial class FormSocketServer : Form
    {
        private System.Text.Encoding enc = System.Text.Encoding.UTF8; // R[h
        private Thread thread;
        private Boolean threadStopper; // Xbh~tO
        private AutoResetEvent threadResetEvent;
        private TcpListener listener;
        private TcpClient tcp;
        public SocketState state;

        public FormSocketServer()
        {
            InitializeComponent();
            connectInit();
        }

        #region Thread/Socket
        /// <summary>
        /// tcp, thread̏
        /// </summary>
        private void connectInit()
        {
            threadResetEvent = new AutoResetEvent(false);
            state = SocketState.DisConnect;
        }

        /// <summary>
        /// tcp, stream, thread̔j
        /// </summary>
        private void connectEnd()
        {
            if (state == SocketState.DisConnect) return;

            threadStopper = true; // XbhItO
            threadResetEvent.WaitOne(); // XbhI҂
            thread = null; // j
            switch (state)
            {
                case SocketState.Connected:
                    try
                    {
                        tcp.Close();
                    }
                    catch (Exception ex)
                    {
                        trace(ex.Message);
                    }
                    break;
                case SocketState.Listening:
                    listener.Stop();
                    break;
            }
            state = SocketState.DisConnect;
        }


        private void listenThreadStart()
        {
            byte[] recvBytes;
            int recvSize = 0;
            System.Net.Sockets.NetworkStream ns;

            threadStopper = false;
            while (!threadStopper)
            {
                switch (state)
                {
                    case SocketState.Listening:
                        if (listener.Pending()) // ڑ҂Ȃ
                        {
                            tcp = listener.AcceptTcpClient(); // ڑ
                            listener.Stop();
                            if (tcp.Connected)
                            {
                                state = SocketState.Connected; // ڑ̏
                                try
                                {
                                    this.Invoke((MethodInvoker)delegate()
                                    {
                                        buttonSendMsg.Enabled = true;
                                        buttonListen.Text = "DisConnect?";
                                    });
                                }
                                catch (Exception ex)
                                {
                                    trace(ex.Message);
                                }
                            }
                        }
                        break;
                    case SocketState.Connected:
                        ns = tcp.GetStream();
                        if (ns.DataAvailable)
                        {
                            recvBytes = new byte[256];
                            try
                            {
                                recvSize = ns.Read(recvBytes, 0, recvBytes.Length);
                            }
                            catch (Exception ex)
                            {
                                trace(ex.Message);
                            }
                            trace("Mf[^: " + recvSize);
                            string recvMsg = enc.GetString(recvBytes);
                            trace("Mf[^: " + recvMsg);
                        }
                        break;
                }

                Thread.Sleep(100);
                threadResetEvent.Set(); // XbhIWaitOne()ɒʒm
            }
        }
        #endregion


        #region UI Event
        private void buttonListen_Click(object sender, EventArgs e)
        {
            switch (state)
            {
                case SocketState.DisConnect:
                    try
                    {
                        textBoxPort.Enabled = false;
                        buttonListen.Text = "Stop Listening?";
                        state = SocketState.Listening;
                        listener = new TcpListener(IPAddress.Any, int.Parse(textBoxPort.Text));
                        listener.Start();
                        thread = new Thread(new ThreadStart(listenThreadStart));
                        thread.Start();
                    }
                    catch (Exception ex)
                    {
                        trace(ex.Message);
                    }
                    break;
                case SocketState.Listening:
                case SocketState.Connected:
                    // ؒf
                    connectEnd();
                    textBoxPort.Enabled = true;
                    buttonSendMsg.Enabled = false;
                    buttonListen.Text = "Listen!";
                    connectInit();
                    break;
            }
        }

        private void buttonSendMsg_Click(object sender, EventArgs e)
        {
            if (!tcp.Connected) return;
            byte[] bytes = enc.GetBytes(textBoxMsg.Text);
            try
            {
                NetworkStream ns = tcp.GetStream();
                ns.Write(bytes, 0, bytes.Length);
            }
            catch (Exception ex)
            {
                trace(ex.Message);
            }
            finally
            {
                trace("M: "+enc.GetString(bytes));
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            connectEnd();
        }
        #endregion


        #region GUI
        /// <summary>
        /// eLXg{bNXɕ\
        /// </summary>
        /// <param name="message"></param>
        public void trace(String message)
        {
            Console.WriteLine(message);
            try
            {
                this.Invoke((MethodInvoker)delegate()
                {
                    textBoxRecv.Text = textBoxRecv.Text + "\r\n" + message;
                });
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }
        #endregion


    }
}