using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net; // socket֘A
using System.Net.Sockets;
using System.Threading; // thread֘A
using System.Collections;

namespace SocketServerBridge
{
    public partial class FormSocketBridge : Form
    {
        private System.Text.Encoding enc = System.Text.Encoding.UTF8; // R[h
        private Thread thread;
        private Boolean threadStopper; // Xbh~tO
        private AutoResetEvent threadResetEvent;
        private TcpListener listener;
        private ArrayList clients;

        public FormSocketBridge()
        {
            InitializeComponent();
            clients = new ArrayList();
        }

        #region Thread/Socke
        /// <summary>
        /// tcp, stream, thread̔j
        /// </summary>
        private void connectEnd()
        {
            if (thread == null) return;

            threadStopper = true; // XbhItO
            threadResetEvent.WaitOne(); // XbhI҂
            thread = null; // j
            listener.Stop();
            for (int i = 0; i < clients.Count; i++)
            {
                try
                {
                    ((TcpClient)clients[i]).Close();
                }
                catch (Exception ex)
                {
                    debug(ex.Message);
                }
            }
        }

        /// <summary>
        /// f[^MXbh
        /// </summary>
        private void recvThreadStart()
        {
            byte[] recvBytes;
            int recvSize = 0;
            threadStopper = false;
            while (!threadStopper)
            {
                if (listener.Pending()) // ڑ҂鎞
                {
                    TcpClient tcp = listener.AcceptTcpClient();
                    clients.Add(tcp);
                    trace("Connected!");
                    trace("ڑ: " + clients.Count);
                }
                else
                {
                    for (int i = 0; i < clients.Count; i++) // 1TCPڑ
                    {
                        TcpClient client = (TcpClient)clients[i];
                        if (!client.Connected)
                        {
                            clients.Remove(client);
                            trace("DisConnected");
                            trace("ڑ: " + clients.Count);
                        }
                        else
                        {
                            NetworkStream ns = client.GetStream();
                            if (ns.DataAvailable) // Mf[^鎞
                            {
                                recvBytes = new byte[3750];
                                try
                                {
                                    recvSize = ns.Read(recvBytes, 0, recvBytes.Length);
                                }
                                catch (Exception ex)
                                {
                                    debug(ex.Message);
                                }
                                debug("Mf[^: " + recvSize);
                                string recvMsg = enc.GetString(recvBytes);
                                debug("Mf[^: " + recvMsg);

                                ArrayList clients2 = new ArrayList();
                                for (int j = 0; j < clients.Count; j++)
                                {
                                    if (i != j) clients2.Add(clients[j]); // Ăzɂ͑ԂȂ
                                }
                                broadcastToClients(recvBytes, clients2);
                            }
                        }
                    }
                }
                Thread.Sleep(10);
            }
            threadResetEvent.Set(); // XbhIWaitOne()ɒʒm
        }

        private void broadcastToClients(byte[] bytes, ArrayList clients)
        {
            for (int i = 0; i < clients.Count; i++)
            {
                TcpClient tcp = (TcpClient)clients[i];
                NetworkStream ns = tcp.GetStream();
                try
                {
                    ns.Write(bytes, 0, bytes.Length);
                }
                catch (Exception ex)
                {
                    debug(ex.Message);
                }
            }
        }

        #endregion

        #region UI Event
        private void buttonListen_Click(object sender, EventArgs e)
        {
            if (thread == null)
            {
                threadResetEvent = new AutoResetEvent(false);
                // listenJn
                listener = new TcpListener(IPAddress.Any, int.Parse(textBoxPort.Text));
                listener.Start();
                trace("Listen!");
                buttonListen.Text = "DisConnect?";
                textBoxPort.Enabled = false;
                thread = new Thread(recvThreadStart);
                thread.Start(); // ڑ҂
            }
            else
            {
                // listen,thread~߂tcpsocket
                connectEnd();
                buttonListen.Text = "Connect!";
                textBoxPort.Enabled = true;
                trace("DisConnected");
            }
        }

        private void FormSocketBridge_FormClosed(object sender, FormClosedEventArgs e)
        {
            connectEnd();
        }
        #endregion

        #region UI Method
        /// <summary>
        /// eLXg{bNXɕ\
        /// </summary>
        /// <param name="message"></param>
        public void trace(String message)
        {
            Console.WriteLine(message);
            if (checkBoxDisplayLog.Checked)
            {
                try
                {
                    this.Invoke((MethodInvoker)delegate()
                    {
                        textBoxLog.Text = textBoxLog.Text + "\r\n" + message;
                    });
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.Message);
                }
            }
        }

        public void debug(String message)
        {
#if DEBUG
            trace(message);
#endif
        }
        #endregion

    }
}